#!/bin/bash
#PBS -l select=25:ncpus=8:model=har
#PBS -N div_correct
#PBS -l walltime=8:00:00

VEL_DIR=/nobackupp1/rpaberna/global_tracer/aviso_0.1_degree-msla
OUT_DIR=/nobackupp1/rpaberna/global_tracer/aviso_0.1_degree-msla_corrected
RUN_DIR=/u/rpaberna/offline_model/global-AVISO/run

module purge
module load comp-intel/11.1.046 mpi/mpt.1.25 netcdf/3.6.0/intel

cd $RUN_DIR

for i in `seq 0 911`
do
    ITER=`printf '%010d' $i`
    
    # test if output files exist
    if [[ -e $OUT_DIR/uvelCorr.$ITER.data && -e $OUT_DIR/vvelCorr.$ITER.data ]]
    then
        echo "Files for $ITER already exist"
    else
        echo "Processing ITER $ITER"
        
        rm STD*
        rm *.data
        rm *.meta
        ln -s $VEL_DIR/vvel.$ITER.data vVelMeanIn.0000010101.data
        ln -s $VEL_DIR/uvel.$ITER.data uVelMeanIn.0000010101.data

        mpiexec ./mitgcmuv > output.log 2>&1

        mv -v uMeanOut.0000010101.data $OUT_DIR/uvelCorr.$ITER.data && 
        mv -v uMeanOut.0000010101.meta $OUT_DIR/uvelCorr.$ITER.meta &&
        mv -v vMeanOut.0000010101.data $OUT_DIR/vvelCorr.$ITER.data &&
        mv -v vMeanOut.0000010101.meta $OUT_DIR/vvelCorr.$ITER.meta
        # make sure it worked
        OUT=$?
        if [ $OUT -eq 0 ]; then
            echo "Copying files successfuly"
        else
            echo "Failed to find uMeanOut files"
            exit $OUT
        fi
    fi

done
